<?

function folder_getid($name, $mother) {
 
 $a_name = sqlslashes($name);
 $sql = "SELECT id, name FROM folder WHERE mother = ".sqlf_tl_num($mother)." AND name= '$a_name'";
 $rs = query($sql);
 if ($rs["num"] > 0) {
 $ret = $rs["arr"][0]["id"];
 } else {
 $ret = false;
 }

 return $ret;
}








 
function folder_exists($name, $mother, $folder_id = 0, $channelset_id = 0) {
 $sql = "SELECT id " . 
 "FROM folder " .
 "WHERE id != " . sql_num($folder_id) . " " .
 "AND LOWER(name) = LOWER(" . sql_str($name) . ") " .
 "AND mother = " . sql_num($mother) . " ";
 
 
 
 
 
 
 if ($channelset_id !== 0 && $channelset_id !== null) {
 $sql .= "AND channelset_id != " . sql_num($channelset_id);
 }
 
 $rs = query($sql);
 
 if ($rs['num'] === 0) {
 return false;
 } else {
 return true;
 }
}



function folder_pagecheck($folder_id,$newname,$type = "page", $rec = false) {

 global $SQLAS;

 if ($type == "page") $sqlpart = "filename";
 else if ($type == "contentfile") $sqlpart = "name";
 else halt(7,"folder_pagecheck: invalid type($type)");

 if( $rec ) {
 $folders = folder_rec_getallids( $folder_id );
 $folders[] = $folder_id;
 $foldersql = implode( ',', sqlf_tl_num_array($folders) );
 
 $sql = "SELECT $type.$sqlpart as filename,MAX(folder.id) as fid,COUNT($type.id) as c FROM folder INNER JOIN $type ON $type.folder_id = folder.id WHERE folder.id IN ($foldersql) OR folder.pub_dir = '".sqlslashes($newname)."' GROUP BY $type.$sqlpart HAVING c > 1";
 $rs = query( $sql );
 if($rs['num'] > 0) {
 $filedebug = '';
 foreach($rs['arr'] as $row) {
 $filedebug .= ' {folder_id:'.$row['fid'].',filename:'.$row['filename'].'}';
 }
 logcmd( W_DEBUG, 10002, $folder_id, 0, 'folder_pagecheck - found duplicate file names: ' . $filedebug );
 return true;
 }
 }

 $sql = "SELECT $type.id FROM folder, $type, folder $SQLAS fold, $type $SQLAS pold 
  WHERE $type.folder_id = folder.id AND folder.pub_dir = '".sqlslashes($newname)."' AND folder.id != ".sqlf_tl_num($folder_id)." 
  AND folder.node_id = fold.node_id
  AND pold.folder_id = fold.id AND fold.id = ".sqlf_tl_num($folder_id)." AND $type.$sqlpart = pold.$sqlpart";
 $rs = query($sql);

 if ($rs["num"] > 0) return true;
 else return false;
}


function cmd_folder_create($name,$mother_id,$pub_dir,$description, $type = "", $startpage = 0) {
 global $TIME,$USER_ID,$T_FOLDER,$DIC,$W_CREATE, $ERROR, $FOLDER_EXISTS;

 
 if ($name === false || $name === "") halt(7, "cmd_folder_create: No name ($name)");
 if (!isset($mother_id) || $mother_id == "") halt(7, "cmd_folder_create: No mother isset or \"\" ($mother_id)");
 
 
 $mother = new CNFolderObject($mother_id);
 $mother_id = $mother->getMasterId();
 
 if (!$type) $type = $T_FOLDER;
 if (!$startpage) $startpage = 0;
 
 if (!perm($USER_ID,$type,$mother_id,8)) {
 $ERROR = i18n('no_permission_to_create_a');
 return false;
 }

 
 $sql = "SELECT node_id, type_id FROM folder WHERE id = ".sqlf_tl_num($mother_id);
 $rs = query($sql);
 $node_id = $rs["arr"][0]["node_id"];
 $mother_type = $rs["arr"][0]["type_id"];

 
 if (!isset($node_id)) halt(7, "cmd_create_folder: node($mother_id) supposed mother does not exist or has no node_id!!");

 if (folder_exists($name, $mother_id)) {
 $ERROR = i18n('a_folder_with_this_name');
 return false;
 }

 
 $name = sqlslashes($name);
 if (!$pub_dir) $pub_dir = "/";
 else {
 if ($pub_dir[0] != "/") $pub_dir = "/".$pub_dir;
 if ($pub_dir[strlen($pub_dir)-1] != "/") $pub_dir .= "/";
 }
 $pub_dir = sqlslashes($pub_dir);
 $description = sqlslashes($description);

 
 $channelsetId = createChannelsetId();

 $sql = "INSERT INTO folder (name,type_id,mother,node_id,pub_dir,description,startpage_id,creator,cdate,editor,edate,channelset_id) 
VALUES ('".sqlf_escaped($name)."',".sqlf_tl_num($type).",".sqlf_tl_num($mother_id).",".sqlf_tl_num($node_id).",'".sqlf_escaped($pub_dir)."','".sqlf_escaped($description)."',".sqlf_tl_num($startpage).",".sqlf_tl_num($USER_ID).",".sqlf_tl_num($TIME).",".sqlf_tl_num($USER_ID).",".sqlf_tl_num($TIME).",".sqlf_tl_num($channelsetId).")";
 $rs = query($sql);
 $folder_id = $rs["iid"];

 duplicate_perm($mother_type, $mother_id, $T_FOLDER, $folder_id); 

 duplicate_tplfolder($mother_id,$folder_id);

 duplicate_foldertags($mother_id,$folder_id);

 
 logcmd($W_CREATE, $type, $folder_id , $node_id, "cmd_folder_create");
 triggerEvent( $T_FOLDER, $folder_id, EVENT_CREATE, new EventObject() );
 triggerEvent( $T_FOLDER, $mother_id, EVENT_UPDATE | EVENT_CHILD, new EventChildObject(T_FOLDER, $folder_id) );

 trigger_event( "onfoldercreate", array("folder_id"=>$mother_id, "new_folder_id"=>$folder_id));

 
 unset($FOLDER_EXISTS[$mother_id]);
 







 return $folder_id;
}

function duplicate_tplfolder($mother_id,$folder_id) {
 $sql = "SELECT template_id FROM template_folder WHERE folder_id = ".sqlf_tl_num($mother_id);
 $rs = query($sql);
 if (is_array($rs["arr"]))
 while (list($key,$val) = each($rs["arr"])) {
 $sql = "INSERT INTO template_folder (template_id, folder_id) VALUES (".sqlf_tl_num($val["template_id"]).",".sqlf_tl_num($folder_id).")";
 query($sql);
 }
}

function duplicate_foldertags($source_id,$target_id) {

 global $T_FOLDER;
 
 $sql = "SELECT id, name FROM objtag WHERE obj_id = ".sqlf_tl_num($source_id)." AND obj_type = ".sqlf_tl_num($T_FOLDER);
 $rs = query($sql);
 if ($rs["num"] > 0) {
 while (list($key,$val) = each($rs["arr"])) {
 $sql = "SELECT inheritable FROM objtag WHERE name = '".sqlf_escaped("{$val['name']}")."' AND obj_id = 0 AND obj_type = ".sqlf_tl_num($T_FOLDER);
 $res = query($sql);
 if ($res['arr'][0]['inheritable'] == 1) {
 
 tag_duplicate($val["id"],"obj",$target_id);
 } else {
 
 }
 }
 }
}


function cmd_folder_update($folder_id,$name,$pub_dir,$description,$rec = false, $startpage = 0) {
 global $TIME,$USER_ID,$DIC,$W_EDIT,$T_FOLDER, $FEATURE;
 
 if (!$folder_id) halt(7,"cmd_folder_update: no folder_id to update.");

 if (!$startpage) $startpage = 0;

 if (!perm($USER_ID,$T_FOLDER,$folder_id,9)) {
 $ERROR = i18n('827.you_have_no_permission_to');
 return false;
 }

 
 $a_name = sqlslashes($name);
 $sql = "SELECT id FROM folder WHERE id = ".sqlf_tl_num($folder_id)." AND name = '".sqlf_escaped($a_name)."'";
 $rs = query($sql);
 $same_name = $rs["arr"][0]["id"];

 if (!$same_name) {
 
 $sql = "SELECT mother FROM folder WHERE id = ".sqlf_tl_num($folder_id);
 $rs = query($sql);
 $mother = $rs["arr"][0]["mother"];
 if (folder_exists($name, $mother)) {
 global $ERROR;
 $ERROR = i18n('a_folder_with_this_name');
 return false;
 }
 }

 $folder_info = get_folderinfo( $folder_id );
 
 if ( $folder_info["pub_dir"] != $pub_dir ) {
 if (folder_pagecheck($folder_id,$pub_dir, 'page', $rec) || folder_pagecheck($folder_id,$pub_dir,"contentfile", $rec)) {
 global $ERROR;
 $ERROR = i18n('the_publishing_directory');
 return false;
 }
 }

 
 if (!$pub_dir) $pub_dir = "/";
 else {
 if ($pub_dir[0] != "/") $pub_dir = "/".$pub_dir;
 if ($pub_dir[strlen($pub_dir)-1] != "/") $pub_dir .= "/";
 }

 
 $modified = array();
 $modified[] = "edate";
 if ( $folder_info["pub_dir"] != $pub_dir ) {
 $modified[] = "pub_dir";
 }
 if ( $folder_info["name"] != $name ) {
 $modified[] = "name";
 }
 if ( $folder_info["description"] != $description ) {
 $modified[] = "description";
 }
 if ( $folder_info["editor"] != $USER_ID ) {
 $modified[] = "editor";
 }

 $name = sqlslashes($name);
 $pub_dir = sqlslashes($pub_dir);
 $description = sqlslashes($description);
 
 $sql = "UPDATE folder SET name = '$name', editor = ".sqlf_tl_num($USER_ID).", edate = ".sqlf_tl_num($TIME).", pub_dir = '$pub_dir', description = '$description', startpage_id = '".sqlf_escaped($startpage)."' WHERE id = ".sqlf_tl_num($folder_id);
 query($sql);

 if ($rec) folder_rec_update($folder_id,$pub_dir);

 
 logcmd($W_EDIT, $T_FOLDER, $folder_id , 0, "cmd_folder_update");
 node_include( "events" );
 
 triggerEvent( $T_FOLDER, $folder_id, EVENT_UPDATE, new EventObject(null, $modified) );

 return $folder_id;
}




function folder_rec_getallids($folder_id) {
 $sql = "SELECT id FROM folder WHERE mother = ".sqlf_tl_num($folder_id);
 $rs = query( $sql );
 $children = array( );
 foreach( $rs['arr'] as $row ) {
 $children[] = $row['id'];
 $children = array_merge( $children, folder_rec_getallids( $row['id'] ) );
 }

 return $children;
}

function folder_rec_update($folder_id,$pub_dir) {

 global $T_FOLDER, $USER_ID, $FEATURE;

 if (perm($USER_ID, $T_FOLDER, $folder_id, 9)) {
 $sql = "UPDATE folder SET pub_dir = '".sqlf_escaped($pub_dir)."' WHERE mother = ".sqlf_tl_num($folder_id);
 query($sql);
 triggerEvent(T_FOLDER, $folder_id, EVENT_UPDATE | EVENT_CHILD, new EventChildObject());
 
 $rs = query("SELECT id FROM folder WHERE mother = ".sqlf_tl_num($folder_id));
 if(is_array($rs["arr"])) {
 while ( list($key, $val) = each($rs["arr"]) ) {
 $id = $val["id"];
 triggerEvent(T_FOLDER, $id, EVENT_UPDATE, new EventObject(null, "pub_dir") );
 }
 }
 }
 if (perm($USER_ID, $T_FOLDER, $folder_id, 0)) {
 $sql = "SELECT id FROM folder WHERE mother = ".sqlf_tl_num($folder_id);
 $rs = query($sql,1);
 if (is_array($rs["arr"]))
 while (list($key,$val) = each($rs["arr"])) {
 $id = $val["id"];
 folder_rec_update($id,$pub_dir);
 }
 }
}




function cmd_folder_unlinkfiles_wf($id) {
 
 global $USER_ID, $T_FOLDER, $ERROR, $DIC, $T_PAGE, $T_FILE;

 $perm = perm($USER_ID,$T_FOLDER,$id);

 $res = true;

 if (!$perm[10]) {
 $ERROR = i18n('878.you_have_no_permission_to');
 return false;
 }

 
 $sql = "SELECT id FROM page WHERE folder_id = ".sqlf_tl_num($id);
 $rs = query($sql,1);
 $page_count = $rs["num"];
 $page_ids = $rs["arr"];
 
 $sql = "SELECT template_id as id FROM template_folder WHERE folder_id = ".sqlf_tl_num($id);
 $rs = query($sql);
 $template_count = $rs["num"];
 $template_ids = $rs["arr"];

 $sql = "SELECT id FROM contentfile WHERE folder_id = ".sqlf_tl_num($id);
 $rs = query($sql);
 $file_count = $rs["num"];
 $file_ids = $rs["arr"];

 $ERROR = "";

 if ($page_count > 0) {
 $sql = "SELECT DISTINCT contentgroup_id FROM page WHERE folder_id = ".sqlf_tl_num($id);
 $rs = query( $sql );
 foreach( $rs['arr'] as $row ) {
 if(!perm($USER_ID, $T_FOLDER, $id, 14, $row['contentgroup_id'], $T_PAGE, 13)) {
 $ERROR = i18n('could_not_delete_folder');
 return false;
 }
 }
 $pages = array();
 if ($page_ids) {
 while (list($key,$val) = each($page_ids)) {
 $pages[$val["id"]] = true;
 }
 }
 cmd_page_del_wf($pages, true, true);
 if ($ERROR) return false;
 }

 
 if ($file_count > 0) {
 if (!perm($USER_ID, $T_FOLDER, $id, 14, NULL, $T_FILE, 13)) {
 $ERROR = i18n('881.could_not_delete_folder');
 return false;
 }
 $files = array();
 if ($file_ids) {
 while(list($key,$val) = each($file_ids)) {
 $files[$val["id"]] = true;
 }
 }
 
 cmd_file_del_wf($files, false);
 }

 return $res;
}


function cmd_folder_unlinkfiles($id) {
 
 global $USER_ID, $T_FOLDER, $ERROR, $DIC, $T_PAGE, $T_FILE;

 $perm = perm($USER_ID,$T_FOLDER,$id);

 $res = true;

 if (!$perm[10]) {
 $ERROR = i18n('878.you_have_no_permission_to');
 return false;
 }

 
 $sql = "SELECT id FROM page WHERE folder_id = ".sqlf_tl_num($id);
 $rs = query($sql,1);
 $page_count = $rs["num"];
 $page_ids = $rs["arr"];
 
 $sql = "SELECT template_id as id FROM template_folder WHERE folder_id = ".sqlf_tl_num($id);
 $rs = query($sql);
 $template_count = $rs["num"];
 $template_ids = $rs["arr"];

 $sql = "SELECT id FROM contentfile WHERE folder_id = ".sqlf_tl_num($id);
 $rs = query($sql);
 $file_count = $rs["num"];
 $file_ids = $rs["arr"];

 $ERROR = "";

 if ($page_count > 0) {
 $sql = "SELECT DISTINCT contentgroup_id FROM page WHERE folder_id = ".sqlf_tl_num($id);
 $rs = query( $sql );
 foreach( $rs['arr'] as $row ) {
 if(!perm($USER_ID, $T_FOLDER, $id, 14, $row['contentgroup_id'], $T_PAGE, 13)) {
 $ERROR = i18n('could_not_delete_folder');
 return false;
 }
 }
 $pages = array();
 if ($page_ids) {
 while (list($key,$val) = each($page_ids)) {
 $pages[$val["id"]] = true;
 }
 }
 cmd_page_del($pages, false, true);
 if ($ERROR) return false;
 }
 
 
 if ($template_count > 0) {
 if(!$perm[18]) {
 $ERROR = i18n('880.could_not_delete_folder');
 return false;
 }
 $templates = array();
 if ($template_ids) {
 while (list($key,$val) = each($template_ids)) {
 $templates[$val["id"]] = true;
 }
 }
 template_del($templates,$id);
 if ($ERROR) return false;
 }
 
 
 if ($file_count > 0) {
 if (!perm($USER_ID, $T_FOLDER, $id, 14, NULL, $T_FILE, 13)) {
 $ERROR = i18n('881.could_not_delete_folder');
 return false;
 }
 $files = array();
 if ($file_ids) {
 while(list($key,$val) = each($file_ids)) {
 $files[$val["id"]] = true;
 }
 }
 cmd_file_del($files);
 }
 
 
 return $res;
}






function cmd_folder_rec_del_wf($id) {
 global $USER_ID, $T_FOLDER, $MAX_EXECTIME;
 
 
 $sql = "SELECT id FROM folder WHERE mother = ".sqlf_tl_num($id);
 $rs = query($sql,1);

 $allowsub = true;

 if ($rs["arr"]) {
 while (list($key,$val) = each($rs["arr"])) {
 $allowsub = cmd_folder_rec_del_wf($val["id"]) && $allowsub;
 }
 }

 set_time_limit($MAX_EXECTIME);
 $allowfolder = cmd_folder_unlinkfiles_wf($id);

 if ($allowsub && $allowfolder) {
 if (perm($USER_ID, $T_FOLDER, $id, 10)) {
 return true;
 } else {
 return false;
 }
 } else {
 return false;
 }
}


function cmd_folder_rec_del($id) {
 global $USER_ID, $T_FOLDER, $MAX_EXECTIME;
 
 
 $sql = "SELECT id FROM folder WHERE mother = ".sqlf_tl_num($id);
 $rs = query($sql,1);

 $allowsub = true;

 if ($rs["arr"]) {
 while (list($key,$val) = each($rs["arr"])) {
 $allowsub = cmd_folder_rec_del($val["id"]) && $allowsub;
 }
 }

 set_time_limit($MAX_EXECTIME);
 $allowfolder = cmd_folder_unlinkfiles($id);

 if ($allowsub && $allowfolder) {
 if (perm($USER_ID, $T_FOLDER, $id, 10)) {
 
 $sql = "DELETE FROM folder WHERE id = ".sqlf_tl_num($id);
 query($sql);
 
 $sql = "DELETE FROM perm WHERE o_type = ".sqlf_tl_num($T_FOLDER)." AND o_id = ".sqlf_tl_num($id);
 query($sql);
 removeEventDependencies( T_FOLDER, $id, EVENT_DEP_ALL );

 
 $tmp = Array();
 $tmp["obj_type"] = $T_FOLDER;
 tags_del($id,"obj",$tmp);
 
 
 logcmd(W_DEL, T_FOLDER, $id , 0, "cmd_folder_rec_del");
 triggerEvent( $T_FOLDER, $id, EVENT_DELETE, new EventObject() );
 return true;
 } else {
 return false;
 }
 } else {
 return false;
 }

 return $res;
}







function cmd_folder_del($id, $foregroundTime = null) {
 global $USER_ID,$TIME,$DIC,$W_DEL,$T_FOLDER;
 global $ERROR, $JAVAPARSER_RETURN;

 
 if (!$id) halt(0,"cmd_folder_del: No folder_id to delete");

 $javaParser =& CodeParser::getJavaParser();

 if ( ! is_array($id) ) {
 $id = array($id => 1);
 }

 $error = false;
 $del_ids = array();
 while (list($key,$val) = each($id)) {

 if ( ! perm_can_delete_folder($key) ) {
 $ERROR = i18n('828.one_or_more_folders_could') .": ".i18n("conflict_reason_permission");
 $error = true;
 continue;
 }

 $folderinfo = get_folderinfo($key);
 if (trigger_event("onfolderdelete", array("old_folder_id" => $key, "folder_id" => $folderinfo["mother"]))) {
 continue;
 }

 if (!cmd_folder_rec_del_wf($key)) {
 $ERROR = i18n('828.one_or_more_folders_could');
 $error = true;
 continue;
 }

 $del_ids[$key] = $key;
 }

 if ( ! empty($del_ids) ) {
 $ERROR = $javaParser->deleteObject(T_FOLDER, $del_ids, $foregroundTime);
 if (!empty($ERROR)) {
 $error = true;
 if (isset($JAVAPARSER_RETURN["params"]["halt"])) {
 halt(7, $ERROR);
 }
 }
 }

 return $error;
}






function folder_is_inherited($ids) {
 global $FEATURE, $NODE_ID;

 if (!$FEATURE["multichannelling"]) {
 return false;
 }

 if (is_array($ids) && count($ids) > 0) {
 $nodeinfo = get_nodeinfo($NODE_ID);
 
 if ($nodeinfo["master_id"] > 0) {
 $sql = "SELECT count(*) c FROM folder WHERE id IN (".sqlf_value_list(implode(",", array_keys($ids))).") AND channel_id != ".sqlf_tl_num($NODE_ID);
 $rs = query($sql);
 return $rs["arr"][0]["c"] > 0;
 } else {
 
 return false;
 }
 } else {
 return false;
 }
}






function folder_contains_localized_copy($ids) {
 global $FEATURE;

 if (!$FEATURE["multichannelling"]) {
 return false;
 }

 if (is_array($ids) && count($ids) > 0) {
 
 $subfolders = array();
 foreach (array_keys($ids) as $folderId) {
 $subfolders = array_merge($subfolders, array_diff(cmd_folder_subfolders($folderId), $subfolders));
 }
 
 $rs = query("SELECT count(*) c FROM page WHERE folder_id IN (".sqlf_value_list(implode(",", $subfolders)).") AND is_master = 0");
 if ($rs["arr"][0]["c"] > 0) {
 
 return true;
 }

 
 $rs = query("SELECT count(*) c FROM contentfile WHERE folder_id IN (".sqlf_value_list(implode(",", $subfolders)).") AND is_master = 0");
 if ($rs["arr"][0]["c"] > 0) {
 
 return true;
 }

 return false;
 } else {
 return false;
 }
}








function cmd_folder_subfolders($folder_id,$perm=0, $restriction_clause = null, $include_root = TRUE) {
 global $USER_ID, $T_FOLDER; 
 
 
 $new = array();
 $ids = array();
 if ($include_root) {
 if ($restriction_clause) {
 
 $sql = "SELECT id FROM folder WHERE (id = ".sqlf_tl_num($folder_id).") AND ($restriction_clause)";
 $rs = query($sql);
 if ($rs["num"] > 0) {
 $ids[] = $folder_id;
 }
 } else {
 $ids[] = $folder_id;
 }
 }
 $new[] = $folder_id;
 
 
 while (count($new) > 0) {

 $tmp = "";
 while (list($key,$val) = each($new)) {
 $tmp .= "mother = ".sqlf_tl_num($val)." OR ";
 }
 $tmp .= "1=2";

 $sql = "SELECT id FROM folder WHERE ($tmp)";
 if($restriction_clause) {
 $sql .= " AND ($restriction_clause)";
 }
 $rs = query($sql,1);
 
 $new = array();
 if ($rs["arr"]) {
 if ($perm) {
 while (list($key,$val) = each($rs["arr"])) {
 if (perm($USER_ID,$T_FOLDER,$val["id"],0)) { $new[] = $val["id"]; $ids[] = $val["id"]; }
 }
 } else {
 while (list($key,$val) = each($rs["arr"])) {
 $new[] = $val["id"];
 $ids[] = $val["id"];
 }
 }
 }
 
 }

 return $ids;
}

function cmd_folder_move($source, $target) {
 global $ERROR,$USER_ID,$TIME,$DIC,$W_MOVE,$T_FOLDER, $T_PAGE, $T_FILE, $T_DOMAIN_CHANNEL, $FEATURE;

 if (!$source) halt(0,"cmd_folder_move: No source to move");
 if (!$target) halt(0,"cmd_folder_move: No target to move");

 
 if (!perm($USER_ID,$T_FOLDER,$target,8)) {
 $ERROR = i18n('829.you_have_no_permission_to');
 return true;
 }

 if ( ! is_array($source) ) {
 $source = array($source => "1");
 }

 $tf = new CNFolderObject($target);
 $target = $tf->getMasterId();

 
 $folderinfo = get_folderinfo($target);

 
 if ($folderinfo["type_id"] == $T_DOMAIN_CHANNEL) {
 
 $target = $folderinfo["master_id"];
 $folderinfo = get_folderinfo($target);
 }

 
 $sql = "SELECT id FROM folder WHERE id IN (".sqlf_value_list(implode(",", array_keys($source))).") AND is_master = 0";
 $locCopies = query($sql);
 while (list($key, $row) = each($locCopies["arr"])) {
 unset($source[$row["id"]]);
 }

 
 while (list($key,$val) = each($source)) {
 
 $ids = cmd_folder_subfolders($key);

 $sourceinfo = get_folderinfo($key);

 
 if (in_array($target,$ids)) {
 
 $ERROR = i18n('target_folder_is_the_same');
 return true;
 }

 
 if ( ! perm_can_delete_folder_root($key) ) {
 $ERROR = i18n('one_or_more_folders_could');
 return true;
 }

 if ($FEATURE["multichannelling"] && $sourceinfo["node_id"] != $folderinfo["node_id"]) {
 
 $sql = "SELECT id FROM folder WHERE is_master = 0 AND channelset_id IN (SELECT channelset_id FROM folder WHERE id IN (" . implode(",", sqlf_tl_num_array($ids)) . ")) AND node_id != ".sqlf_tl_num($folderinfo["node_id"]);
 $rs = query($sql);
 if ($rs["num"] > 0) {
 $ERROR = i18n("folder.move.localization.error");
 return true;
 }

 
 $sql = "SELECT count(*) c FROM page WHERE folder_id IN (" . implode(",", sqlf_tl_num_array($ids)) . ") AND is_master = 0";
 $rs = query($sql);
 if ($rs["arr"][0]["c"] > 0) {
 $ERROR = i18n("folder.move.localization.error");
 return true;
 }
 $sql = "SELECT count(*) c FROM contentfile WHERE folder_id IN (" . implode(",", sqlf_tl_num_array($ids)) . ") AND is_master = 0";
 $rs = query($sql);
 if ($rs["arr"][0]["c"] > 0) {
 $ERROR = i18n("folder.move.localization.error");
 return true;
 }
 }

 $tmp .= " id = ".sqlf_tl_num($key)." OR";
 $log[] = $key;

 
 $sql = "SELECT id FROM folder WHERE is_master = 0 AND channelset_id IN (SELECT channelset_id FROM folder WHERE id = ".sqlf_tl_num($key).")";
 $rs = query($sql);
 while (list($k1, $row) = each($rs["arr"])) {
 $tmp .= " id = ".sqlf_tl_num($row["id"])." OR";
 $log[] = $row["id"];
 }
 }

 
 $sql = "SELECT name FROM folder WHERE $tmp 1=2";
 $rs = query($sql);
 
 while (list($k,$v) = each($rs["arr"])) {
 if (folder_exists($v["name"], $target)) {
 $ERROR = count($source) > 1 ? i18n('ein_namen_eines_quellordners_existiert_bereits_im_zielordner') : i18n('451.a_folder_with_this_name');
 return true;
 }
 }

 
 
 $sql = "SELECT DISTINCT mother FROM folder WHERE $tmp 1=2";
 $rsM = query($sql);

 
 $sql = "UPDATE folder SET mother = ".sqlf_tl_num($target).", edate = ".sqlf_tl_num($TIME).", editor = ".sqlf_tl_num($USER_ID)." WHERE $tmp 1=2";
 query($sql);

 
 reset($log);
 while (list($k, $v) = each ($log)) {
 logcmd($W_MOVE, $T_FOLDER, $v , $target, "cmd_folder_move");
 
 triggerEvent(T_FOLDER, $v, EVENT_MOVE, new EventObject(array("type"=>"toFolder", "toId"=>$target) ) );
 }
 
 triggerEvent(T_FOLDER, $target, EVENT_MOVE | EVENT_CHILD, new EventChildObject( array( "newFolderIds" => $log ) ) );

 
 
 
 $sql = "SELECT id FROM folder WHERE $tmp 1=2";
 $rs = query($sql);
 foreach($rs["arr"] as $folder) {
 
 $subfolders = cmd_folder_subfolders($folder["id"], 0, "node_id != ".sqlf_tl_num($folderinfo["node_id"]));
 while (list($subfolder,$val) = each($subfolders)) {
 $subfolder_info = get_folderinfo($val);
 
 $sql = "UPDATE folder SET node_id = ".sqlf_tl_num($folderinfo["node_id"])." WHERE id = ".sqlf_tl_num($val);
 query($sql);
 logcmd($W_MOVE, $T_FOLDER, $val, $target, "cmd_folder_move (folder to other node)");
 
 triggerEvent($T_FOLDER, $val, EVENT_MOVE, new EventObject(array("type"=>"toNode", "toId"=>$target), array($subfolder_info["node_id"])));

 
 $sql = "SELECT id FROM page WHERE folder_id = ".sqlf_tl_num($val);
 $page_rs = query($sql);
 foreach ($page_rs["arr"] as $page) {
 logcmd($W_MOVE, $T_PAGE, $page["id"], $target, "cmd_folder_move (page to other node)");
 }
 $sql = "SELECT id FROM contentfile WHERE folder_id = ".sqlf_tl_num($val);
 $file_rs = query($sql);
 foreach ($file_rs["arr"] as $file) {
 logcmd($W_MOVE, $T_FILE, $file["id"], $target, "cmd_folder_move (file to other node)");
 }
 }
 }

 
 
 foreach($rsM["arr"] as $mothers) {
 triggerEvent(T_FOLDER, $mothers["mother"], EVENT_MOVE | EVENT_CHILD, new EventChildObject(array("oldFolderIds" => $log)));
 }

 return false;
}

function cmd_switch_tofolder( $id )
{
 global $FOLDER_ID, $JS, $STAG, $T_FOLDER, $NODE_ID, $FEATURE, $CN_LOCAL_SERVER, $PORTLETAPP_PREFIX_INTERNAL, $SESSION_TOKEN;

 
 $folder = get_folderinfo($id);
 
 if (!$NODE_ID) {
 $NODE_ID = $folder["node_id"];
 }

 
 if ($FEATURE["multichannelling"] && $folder["channelset_id"] != 0) {
 $local = doMultichannellingFallback(T_FOLDER, $folder["channelset_id"], $NODE_ID);
 if ($local) {
 $id = $local["id"];
 }
 }

 if ( $FOLDER_ID == $id ) return;
 $FOLDER_ID = $id;

 if ($FEATURE["multichannelling"]) {
 $fc = new fetchCurl();
 $url = $CN_LOCAL_SERVER . $PORTLETAPP_PREFIX_INTERNAL . "rest/folder/load/$id?sid=$SESSION_TOKEN&nodeId=$NODE_ID";
 $fc->setUrl($url);
 $json = $fc->doRequest();

 
 if ($fc->getReturnCode() == '') {
 halt(7,'Unable to connect to CNPortletapp for switching folders.');
 } else if ($fc->getReturnCode() >= 400) {
 halt(120, 'Accessing CNPortletapp returned error '.$fc->getReturnCode());
 }

 $folder = json_decode($json,true);
 $atposidx = "-1".$folder['folder']['atposidx'];
 } else {
 $ftree = get_folder_tree($id);
 $atposidx = build_atposidx( $ftree );
 }
 $JS .= "top.tree.location.href='$STAG&do=300&open_type=$T_FOLDER".
 "&open_id=$id&atposidx=$atposidx';";
}

function cmd_copy_folder( $folder_id, $new_mother_id, $new_name = "", $node_id = 0 ) {

 $sql = "SELECT * FROM folder WHERE id = ".sqlf_tl_num($folder_id);
 $rs = query($sql);

}

?>
