<?
GUIFactory::setMainGUI( "main" );

$constructs = get_constructlist_by_category();

$tmp = $HI["hidden"];
$tmp["var"] = "id";
$hi[] = $tmp;

if (!$id && $f_id) $id = $f_id;
if(!$limit_to_nodes && $f_limit_to_nodes) $limit_to_nodes = $f_limit_to_nodes;
if ($id) {
 
 $objtag = getObjTag( $id );
 $name = substr($objtag["name"],strpos($objtag["name"],".") + 1);
 $tagname = $objtag["name"];
 $cid = $objtag["construct_id"];
 $o_type = $objtag["obj_type"];
 $OBJPROP = $o_type;
 $required = $objtag["required"];
 
 $inheritable = $objtag["inheritable"];

 $objprop = getObjProp( $id );
 $objprop_id = $objprop["id"];
 $readablename = $objprop["name"];
 $description = $objprop["description"];
 $category = $objprop["category_id"];
 
 

 if( $objprop_id ) {
 $sql = "SELECT * FROM objprop_node WHERE objprop_id = '".sqlf_escaped($objprop_id)."'";
 $rs = query( $sql );
 if( count( $rs['arr'] ) > 0 ) {
 if( !$limit_to_nodes ) {
 $limit_to_nodes = 'limit';
 }
 $nodes = array();
 foreach( $rs['arr'] as $row ) {
 $nodes[] = $row['node_id'];
 }
 }
 
 }


}
 if(!$limit_to_nodes)
 $limit_to_nodes = 'nolimit';



$tmp = $HI["text"];
$tmp["var"] = "readablename";
$tmp["optional"] = true;
$tmp["label"] = i18n( "Descriptive Name" );
$tmp["help"] = i18n( "A descriptive name which will be presented to the user in the Object Property list." );
$hi[] = $tmp;

$tmp = $HI["text"];
$tmp["var"] = "name";
$tmp["regid"] = REG_NODETAG;
$tmp['help'] = i18n('Keyword which is used as internal identifier for this Object Property.');
$tmp['error'] = i18n('enter valid keyword');
$tmp['label'] = i18n('Keyword');
if ( $cmd == 'new' || $f_cmd == 'new') {
 $tmp['disable'] = false;
} else if ($FEATURE['template_objprop']) {
 $tmp['disabled'] = true;
}
$hi[] = $tmp;

$tmp = $HI["sel"];
$tmp["label"] = i18n( 'tagtype_singular' );
$tmp["var"] = "cid";
if($FEATURE['construct_categories']) {
 $tmp['grouped'] = TRUE;
}
$tmp["list"] = ($FEATURE['construct_categories'] ? create_construct_selectbox($constructs) : reduce_array($constructs,"id","name"));
$hi[] = $tmp;








$sql = "SELECT objprop_category.id, name_id, dicuser.value AS name from objprop_category LEFT JOIN dicuser ON dicuser.output_id = objprop_category.name_id AND dicuser.language_id = ".sqlf_tl_num($LANGUAGE)." ORDER BY sortorder";
$rs = query( $sql );
$categories = reduce_array( $rs['arr'], 'id', 'name' );


$tmp = $HI["sel"];
$tmp["var"] = "category";
$tmp["label"] = i18n( "Category" );
$tmp["optional"] = true;
$tmp["help"] = i18n( "Choose a Category this property is part of." );
$tmp["list"] = $categories;
$hi[] = $tmp;

$tmp = $HI["checkbox"];
$tmp["var"] = "required";
$tmp["label"] = i18n( "required property" );
$tmp["help"] = i18n( "Marks a Object Property as required. Will not affect currently published Object Properties." );
$hi[] = $tmp;

if( $o_type == $T_FOLDER || $o_type == $T_TEMPLATE ) {
 $tmp = $HI["checkbox"];
 $tmp["var"] = "inheritable";
 $tmp["label"] = i18n( "Inheritable" );
 $tmp["help"] = i18n( "Marks this Object Property as beeing inherited from Folders and Templates to Pages and Files." );
 $hi[] = $tmp;
 






}

$tmp = $HI["sel"];
$tmp["var"] = "limit_to_nodes";
$tmp["onchange"] = "&1=1";
$tmp["label"] = i18n( "Limit to Nodes" );
$tmp["list"] = array( 'nolimit' => i18n( "All Nodes" ), 'limit' => i18n( "Limit to specific Nodes" ) );
$hi[] = $tmp;

if( $limit_to_nodes == 'limit' ) {
 $sql = "SELECT node.id, folder.name FROM node INNER JOIN folder ON node.folder_id = folder.id WHERE folder.master_id = 0 ORDER BY folder.name";
 $rs = query( $sql );
 $allnodes = reduce_array( $rs['arr'], 'id', 'name' );
 $tmp = $HI["sel"];
 $tmp["var"] = "nodes";
 $tmp["label"] = i18n( "Nodes" );
 $tmp["help"] = i18n( "Allows you to limit the Object Property to specific nodes. If none is selected it will apply to all Nodes." );
 $tmp["multiple"] = true;
 $tmp["size"] = 15;
 $tmp["list"] = $allnodes;
 $hi[] = $tmp;
}

$tmp = $HI["ta"];
$tmp["var"] = "description";
$tmp["label"] = i18n( "Description" );
$tmp["help"] = i18n( "Some text describing the use of this object property." );
$hi[] = $tmp;

$allowedit = true;
if ($FEATURE['objtag_perm']) {
 if ($id) {
 $allowedit = perm($USER_ID, $T_OBJPROPELEMENT, $id, 2);
 } else {
 $allowedit = perm($USER_ID,$T_OBJPROP,$OBJPROP,2);
 }
}

if ( !$FEATURE['deactivate_objpropedit'] && $allowedit) {
 $hi[] = $HI["ok"];
}
$hi[] = $HI["cancel"];

$f = new htmlform($hi);

function getObjTag($id) {
 $sql = "SELECT name, construct_id, obj_type, required, inpage, inheritable FROM objtag WHERE id = ".sqlf_tl_num($id);
 $rs = query($sql);
 return $rs["arr"][0];
}
function getObjProp($id) {
 global $LANGUAGE;
 $sql = "SELECT objprop.id, name_id, description_id, category_id, dicname.value AS name, dicdescr.value AS description FROM objprop LEFT JOIN dicuser AS dicname ON dicname.output_id = objprop.name_id AND dicname.language_id = ".sqlf_tl_num($LANGUAGE)." LEFT JOIN dicuser AS dicdescr ON dicdescr.output_id = objprop.description_id AND dicdescr.language_id = ".sqlf_tl_num($LANGUAGE)." WHERE objtag_id = '".sqlf_escaped($id)."'";
 $rs = query($sql);
 return $rs["arr"][0];
}

if ($faction == "ok") {
 if(!$inheritable) $inheritable = 0;
 
 if(!$required) $required = 0;
 if (!$f->err) {
 if (!$id) {
 $res = cmd_objprop_create($name,$cid,$OBJPROP,$required,NULL,$inheritable);
 if ($res) $id = $res;
 else {
 list($key,$val) = each($ERROR);
 $f->check[$key] = $val;
 }
 } else {
 $res = cmd_objprop_update($id,$name,$cid,$OBJPROP,$required,NULL,$inheritable);
 if (!$res) {
 list($key,$val) = each($ERROR);
 $f->check[$key] = $val;
 }
 }
 if ($res) {
 $objprop = getObjProp( $id );
 if( !$objprop ) {
 $name_id = word( $readablename, 6 );
 $descr_id = word( $description, 6 );
 $sql = "INSERT INTO objprop (objtag_id, o_type, name_id, description_id, category_id) values ('".sqlf_escaped($id)."','".sqlf_escaped($o_type)."', '".sqlf_escaped($name_id)."', '".sqlf_escaped($descr_id)."', '".sqlf_escaped($category)."')";
 $rs = query( $sql );
 $objprop_id = $rs['iid'];
 } else {
 $objprop_id = $objprop['id'];

 $name_id = word( $readablename, 6, $objprop['name_id'] );
 $descr_id = word( $description, 6, $objprop['description_id'] );
 if( $name_id != $objprop['name_id'] || $descr_id != $objprop['description_id'] ) {
 $sql = "UPDATE objprop SET name_id = '".sqlf_escaped($name_id)."', description_id = '".sqlf_escaped($descr_id)."' WHERE id = '".sqlf_escaped($objprop_id)."'";
 query( $sql );
 }

 $sql = "UPDATE objprop SET category_id = '".sqlf_escaped($category)."' WHERE id = '".sqlf_escaped($objprop_id)."'";
 query( $sql );
 }

 $sql = "DELETE FROM objprop_node WHERE objprop_id = '".sqlf_escaped($objprop_id)."'";
 query( $sql );
 if( $limit_to_nodes == 'limit' ) {
 foreach( $nodes AS $node ) {
 $sql = "INSERT INTO objprop_node (objprop_id,node_id) values ('".sqlf_escaped($objprop_id)."','".sqlf_escaped($node)."')";
 query( $sql );
 }
 }

 $id = $OBJPROP;
 $REDO = 450;
 }
 } 
 if ($LOAD_MODULE["content"]) CNDirt::dirtAll();
}

if ($faction == "cancel") {
 $REDO = 450;
 $id = $OBJPROP;
}

load_menu(457,$T_OBJPROP,$id);

?>
